import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.file.FileAlreadyExistsException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;

import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
import org.apache.commons.compress.archivers.zip.ZipArchiveInputStream;
import org.apache.commons.compress.archivers.zip.ZipArchiveOutputStream;
import org.apache.commons.io.IOUtils;

public  class Test
{
    public static void main(final String[] args) throws Exception
    {
        int numberEntriesRead = 0;
        try (InputStream in = new BufferedInputStream(Files.newInputStream(Paths.get("in.zip")));
             OutputStream os = new BufferedOutputStream(Files.newOutputStream(Paths.get("out.zip"), StandardOpenOption.CREATE_NEW));
             ZipArchiveOutputStream zipOutputStream = new ZipArchiveOutputStream(os);
             ZipArchiveInputStream zipInputStream = new ZipArchiveInputStream(in))
        {
            for (ZipArchiveEntry entry = zipInputStream.getNextZipEntry(); entry != null; entry = zipInputStream.getNextZipEntry())
            {
                try
                {
                    System.out.println("Read: " + entry.getName());
                    zipOutputStream.putArchiveEntry(entry);
                    IOUtils.copy(zipInputStream, zipOutputStream);
                }
                finally
                {
                    // Make sure the entry is always closed in case there is an error during the read.
                    zipOutputStream.closeArchiveEntry();
                }
                numberEntriesRead++;
            }
        }
        catch (Exception e)
        {
            System.out.println("Error: " + e.getMessage());
            e.printStackTrace();
        }

        System.out.println("Copied: " + numberEntriesRead);
    }
}